---
title: FileSystemFileHandle
slug: Web/API/FileSystemFileHandle
tags:
  - Directory
  - File
  - File System Access API
  - FileSystemFileHandle
  - Interface
  - working with files
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>FileSystemFileHandle</code></strong> interface of the {{domxref('File System Access API')}} represents a handle to a file system entry. The interface is accessed thought the {{domxref('window.showOpenFilePicker()')}} method.</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{DOMxRef("FileSystemHandle")}}.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{DOMxRef("FileSystemHandle")}}.</em></p>

<dl>
 <dt>{{domxref('FileSystemFileHandle.getFile', 'getFile()')}}</dt>
 <dd>Returns a {{domxref('File','file object')}} representing the state on disk of the entry represented by the handle.</dd>
 <dt>{{domxref('FileSystemFileHandle.createWritable', 'createWritable()')}}</dt>
 <dd>Creates a {{domxref('FileSystemWritableFileStream')}} that can be used to write to a file.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Reading_a_File">Reading a File</h3>

<p>The following asynchronous function presents a file picker and once a file is chosen, uses the <code>getFile()</code> method to retrieve the contents.</p>

<pre class="brush: js notranslate">async function getTheFile() {
  // open file picker
  [fileHandle] = await window.showOpenFilePicker(pickerOpts);

  // get file contents
  const fileData = await fileHandle.getFile();
}</pre>

<h3 id="Writing_a_File">Writing a File</h3>

<p>The following asynchronous function writes the given contents to the file handle, and thus to disk.</p>

<pre class="brush: js notranslate">async function writeFile(fileHandle, contents) {
  // Create a FileSystemWritableFileStream to write to.
  const writable = await fileHandle.createWritable();

  // Write the contents of the file to the stream.
  await writable.write(contents);

  // Close the file and write the contents to disk.
  await writable.close();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access','#api-filesystemfilehandle','FileSystemFileHandle')}}</td>
   <td>{{Spec2('File System Access')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemFileHandle")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
